#include <Adafruit_NeoPixel.h>
#ifdef _AVR_
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

int inp[4]={2,3,4,5}; // arduino pins that connect to keyboard
int outp[4]={6,7,8,9}; // arduino pins that connect to keyboard
int prevstate[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
int command[40]={0};
int cind=0;
#define PIN_NEO_PIXEL 11  // Arduino pin that connects to NeoPixel
#define NUM_PIXELS 20   // The number of LEDs (pixels) on NeoPixel
#define DELAY_INTERVAL 10
Adafruit_NeoPixel NeoPixel(NUM_PIXELS, PIN_NEO_PIXEL, NEO_GRB + NEO_KHZ800);
void setup() {
  for(int i=0; i<4; i++) {
    pinMode(inp[i], INPUT_PULLUP);
    pinMode(outp[i], OUTPUT);
    digitalWrite(outp[i], HIGH);
  }
  Serial.begin(9600);
  NeoPixel.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
  
  NeoPixel.clear(); // set all pixel colors to 'off'
}



void execute() {

  int pixel=-1, r=-1, g=-1, b=-1;
  for(int k=0; k<40;k++){
    if(command[k]==11){
      r=command[++k]*100+command[++k]*10+command[++k]; // press B to select the amount of red (0-255)
    }
    else if(command[k]==12){
      g=command[++k]*100+command[++k]*10+command[++k]; // press C to select the amount of green (0-255)
    }
    else if(command[k]==13){
      b=command[++k]*100+command[++k]*10+command[++k]; // press D to select the amount of blue (0-255)
    }
    else if(command[k]==10){
       int stanza=command[++k]*10+command[++k]; // press A to select the classroom in which the pixel is located, then press the corresponding number (the following piece of code is an example)
       
       if (stanza==1){
        pixel=6;
       }
        
       if (stanza==2){
        pixel=5;
       }
        
       if (stanza==3){
        pixel=4;
       }
               
       if (stanza==4){
        pixel=3;
       }
               
       if (stanza==5){
        pixel=2;
       }
               
       if (stanza==6){
        pixel=1;
       }
               
       if (stanza==7){
        pixel=0;
       }
               
       if (stanza==8){
        pixel=10;
       }
               
       if (stanza==9){
        pixel=9;
       }
               
       if (stanza==10){
        pixel=8;
       }
               
       if (stanza==11){
        pixel=7;
       }
               
       if (stanza==12){
        pixel=13;
       }
               
       if (stanza==13){
        pixel=12;
       }
               
       if (stanza==14){
        pixel=11;
       }
               
       if (stanza==15){
        pixel=14;
       }
    }
  }
  if(r==-1 && g==-1 && b==-1){
    r=255;
    g=255;
    b=255; // if no color is selected, the color will be white
  } else{
    if(r==-1){
      r=0;
    }
    if(g==-1){
      g=0;
    }
    if(b==-1){
      b=0;
    } //if any color is selected, the remaining non-selected ones will be off
  }
  if(pixel==-1){
    return; //cancels if no classroom is selected
  }
  NeoPixel.setPixelColor(pixel, NeoPixel.Color(r, g, b));
  Serial.print(r);
  Serial.print(" ");
  Serial.print(g);
  Serial.print(" ");
  Serial.println(b);
  NeoPixel.show();
}

void loop() { //this section concerns the keyboard. if a key is pressed, then it will have coordinates corresponding to the pins, each coordinate is named and printed in command
  for(int i=0; i<4; i++) {
    digitalWrite(outp[i], LOW);
    for(int j=0; j<4; j++) {
      if(!digitalRead(inp[j])){
        if(!prevstate[i][j]) {
          /*Serial.print(i);
          Serial.print(", ");
          Serial.println(j);*/ // ignore this
          prevstate[i][j]=1;
         
          
          if(i==0 && j==3){ //erase command when pressing "*"
            for(int k=0; k<40; k++) {command[k]=0;}
            cind=0;
            for(int pixel = 0; pixel < NUM_PIXELS; pixel++){
               // for each pixel
             NeoPixel.setPixelColor(pixel, NeoPixel.Color(0, 0, 0)); // it only takes effect if pixels.show() is called
             NeoPixel.show();   // send the updated pixel colors to the NeoPixel hardware.

             delay(DELAY_INTERVAL); // pause between each pixel
            }
          }
          if(i==0 && j==1){ //execute command
            execute();
            for(int k=0; k<40; k++) {command[k]=0;}
            cind=0;
          }
          if(i==0 && j==2){ //0
            command[cind++]=0;
          }
          if(i==3 && j==3){ //1
            command[cind++]=1;
          }
          if(i==3 && j==2){ //2
            command[cind++]=2;
          }
          if(i==3 && j==1){ //3
            command[cind++]=3;
          }
          if(i==2 && j==3){ //4
            command[cind++]=4;
          }
          if(i==2 && j==2){ //5
            command[cind++]=5;
          }
          if(i==2 && j==1){ //6
            command[cind++]=6;
          }
          if(i==1 && j==3){ //7
            command[cind++]=7;
          }
          if(i==1 && j==2){ //8
            command[cind++]=8;
          }
          if(i==1 && j==1){ //9
            command[cind++]=9;
          }
          if(i==3 && j==0){ //A
            command[cind++]=10;
          } 
          if(i==2 && j==0){ //B
            command[cind++]=11;
          } 
          if(i==1 && j==0){ //C
            command[cind++]=12;
          }
          if(i==0 && j==0){ //D
            command[cind++]=13;
          }
        }
      }
      else{
        prevstate[i][j]=0;
      }      
    }
    digitalWrite(outp[i], HIGH);
  }
}